"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunk6J4V2ZZ4cjs = require('./chunk-6J4V2ZZ4.cjs');

// src/createClient.ts
var _isomorphicws = require('isomorphic-ws'); var _isomorphicws2 = _interopRequireDefault(_isomorphicws);
var _msgpackr = require('msgpackr');

// src/utils/createIntegroPromise.ts
var _args = Symbol("args");
var _setPromise = Symbol("setPromise");
var createIntegroPromise = (executor, ...args) => {
  let promise;
  return {
    [Symbol.toStringTag]: "IntegroPromise",
    [_args]: args,
    [_setPromise]: (nativePromise) => {
      promise ??= nativePromise;
    },
    catch: (onrejected) => {
      promise ??= Promise.resolve(executor(...args));
      return promise.catch(onrejected);
    },
    finally: (onfinally) => {
      promise ??= Promise.resolve(executor(...args));
      return promise.finally(onfinally);
    },
    then: (onfulfilled, onrejected) => {
      promise ??= Promise.resolve(executor(...args));
      return promise.then(onfulfilled, onrejected);
    }
  };
};
var getIntegroPromiseArgs = (promise) => promise[_args];
var setIntegroPromiseValue = (promise, nativePromise) => {
  _optionalChain([promise, 'access', _ => _[_setPromise], 'optionalCall', _2 => _2(nativePromise)]);
};
var isIntegroPromise = (promise) => !!promise && typeof promise === "object" && promise.toString() === "[object IntegroPromise]" && Array.isArray(promise[_args]);
var isIntegroPromises = (promises) => promises.every(isIntegroPromise);

// src/utils/noop.ts
var noop = () => {
};

// src/utils/createProxy.ts
var createProxy = (apply, path = []) => new Proxy(noop, {
  get: (_target, key) => key === Symbol.toStringTag ? path.join(".") : createProxy(apply, [...path, key.toString()]),
  apply: (_target, _thisArg, args) => apply(path, args)
});

// src/utils/isArrayEqual.ts
var isArrayEqual = (a, b) => a.length === b.length && a.every((value, index) => value === b[index]);

// src/createClient.ts
var post = async (options) => {
  const { url, config } = Array.isArray(options) ? options[0] : options;
  const data = Array.isArray(options) ? options.map((o) => o.data) : options.data;
  const init = typeof config.requestInit === "function" ? config.requestInit() : config.requestInit;
  const auth = typeof config.auth === "function" ? config.auth() : config.auth;
  const res = await fetch(url, {
    method: "POST",
    ...init,
    headers: {
      "Content-Type": "application/msgpack",
      ...auth ? { "Authorization": auth } : void 0,
      ..._optionalChain([init, 'optionalAccess', _3 => _3.headers])
    },
    body: _msgpackr.pack.call(void 0, data)
  });
  const arrayBuffer = await res.arrayBuffer();
  const unpacked = _msgpackr.unpack.call(void 0, new Uint8Array(arrayBuffer));
  if (!res.ok) {
    if (typeof unpacked === "object" && unpacked !== null && Object.getPrototypeOf(unpacked) === Object.prototype && "message" in unpacked && typeof unpacked.message === "string" && unpacked.message.length) {
      throw new Error(unpacked.message);
    }
    throw new Error("The server responded in error.", {
      cause: unpacked
    });
  }
  return unpacked;
};
var subscribe = ({
  url,
  config,
  data: { path, args },
  websocket
}) => {
  const handler = args[args.length - 1];
  const sendArgs = args.slice(0, args.length - 1);
  if (typeof handler !== "function")
    throw new Error("Last parameter must be a callback function.");
  const listener = (data) => {
    const unpacked = _msgpackr.unpack.call(void 0, new Uint8Array(data));
    if (unpacked.type === "error") {
      handler(void 0, unpacked.message);
      _optionalChain([websocket, 'access', _4 => _4.current, 'optionalAccess', _5 => _5.off, 'call', _6 => _6("message", listener)]);
    }
    ;
    if (unpacked.type !== "event")
      return;
    if (!isArrayEqual(unpacked.path, path))
      return;
    handler(unpacked.message);
  };
  websocket.current ??= new (0, _isomorphicws2.default)(url);
  websocket.current.on("error", console.error);
  websocket.current.on("message", listener);
  websocket.isOpen ? _optionalChain([websocket, 'access', _7 => _7.current, 'optionalAccess', _8 => _8.send, 'call', _9 => _9(_msgpackr.pack.call(void 0, { type: "subscribe", auth: config.auth, path, args: sendArgs }))]) : websocket.current.on("open", () => {
    websocket.isOpen = !!websocket.current;
    _optionalChain([websocket, 'access', _10 => _10.current, 'optionalAccess', _11 => _11.send, 'call', _12 => _12(_msgpackr.pack.call(void 0, { type: "subscribe", auth: config.auth, path, args: sendArgs }))]);
  });
  return () => {
    _optionalChain([websocket, 'access', _13 => _13.current, 'optionalAccess', _14 => _14.off, 'call', _15 => _15("message", listener)]);
  };
};
var createClient = (url = "/", config = {}) => {
  const websocket = { current: void 0, isOpen: false };
  return createProxy(
    (path, args) => path.length >= 2 && path[path.length - 1] === (_nullishCoalesce(config.subscribeKey, () => ( "subscribe"))) ? subscribe({
      url,
      config,
      data: {
        path,
        args
      },
      websocket
    }) : createIntegroPromise(post, { url, config, data: { type: "request", path, args } })
  );
};

// src/batch.ts
var assertPostOptions = (value) => {
  if (!Array.isArray(value) || !value[0] || typeof value[0] !== "object" || typeof value[0].url !== "string" || !value[0].config || typeof value[0].config !== "object") {
    throw new Error("Only IntegroPromises can be batched");
  }
  try {
    _chunk6J4V2ZZ4cjs.assertRequestData.call(void 0, value[0].data);
  } catch (e) {
    throw new Error("Only IntegroPromises can be batched");
  }
  return value.slice(0, 1);
};
var batch = (type) => (promises) => {
  if (!isIntegroPromises(promises))
    throw new Error("Only IntegroPromises can be batched");
  const allPostOptions = promises.map(
    (promise) => assertPostOptions(getIntegroPromiseArgs(promise))[0]
  );
  const executor = (options) => post(options).then((results) => {
    results.forEach((result, index) => {
      if (type === "all" || type === "allSequential") {
        setIntegroPromiseValue(promises[index], Promise.resolve(result));
      } else {
        const settledResult = result;
        setIntegroPromiseValue(promises[index], settledResult.status === "fulfilled" ? Promise.resolve(settledResult.value) : Promise.reject(settledResult.reason));
      }
    });
    return results;
  });
  const batchPromise = promises.length === 0 ? createIntegroPromise(() => []) : createIntegroPromise(executor, {
    url: allPostOptions[0].url,
    config: allPostOptions[0].config,
    data: {
      type,
      data: allPostOptions.map(({ data }) => data)
    }
  });
  Object.assign(batchPromise, {
    *[Symbol.iterator]() {
      for (const promise of promises) {
        yield promise;
      }
      yield () => batchPromise;
    }
  });
  return batchPromise;
};
var all = batch("all");
var allSequential = batch("allSequential");
var allSettled = batch("allSettled");
var allSettledSequential = batch("allSettledSequential");






exports.all = all; exports.allSequential = allSequential; exports.allSettled = allSettled; exports.allSettledSequential = allSettledSequential; exports.createClient = createClient;
