"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }




var _chunk6J4V2ZZ4cjs = require('./chunk-6J4V2ZZ4.cjs');

// src/createController.ts
var _msgpackr = require('msgpackr');
var _http = require('http');

// src/respondWith.ts
var _isResponseInitObject = Symbol("isResponseInitObject");
var respondWith = (data, responseInit) => ({
  [_isResponseInitObject]: true,
  data,
  responseInit
});
var isResponseInitObject = (object) => typeof object === "object" && object !== null && object[_isResponseInitObject] === true;

// src/createSubject.ts
var filterSubject = (source, filter) => {
  const subject = createSubject({ onUnsubscribe: (count) => {
    count === 0 && unsubscribeTarget();
  } });
  const unsubscribeTarget = source.subscribe((message) => {
    filter(message) && subject.send(message);
  });
  return subject;
};
var mapSubject = (source, mapper) => {
  const subject = createSubject({ onUnsubscribe: (count) => {
    count === 0 && unsubscribeTarget();
  } });
  const unsubscribeTarget = source.subscribe((message) => {
    const mappedMessage = mapper(message);
    if (mappedMessage)
      subject.send(mappedMessage);
  });
  return subject;
};
var createSubject = (config = {}) => {
  const subscriptions = /* @__PURE__ */ new Set();
  const subject = {
    _subscriptionCount: () => subscriptions.size,
    filter: (filter) => filterSubject(subject, filter),
    map: (mapper) => mapSubject(subject, mapper),
    send: (message) => {
      Array.from(subscriptions.keys()).forEach((handler) => handler(message));
    },
    subscribe: (handler) => {
      subscriptions.add(handler);
      return () => {
        subscriptions.delete(handler);
        _optionalChain([config, 'access', _ => _.onUnsubscribe, 'optionalCall', _2 => _2(subscriptions.size)]);
      };
    }
  };
  return subject;
};
var isSubject = (object) => typeof object === "object" && object !== null && typeof object.subscribe === "function";

// src/unwrap.ts
var _isUnwrappable = Symbol("isUnwrappable");
var unwrap = (handler) => {
  const fn = (context) => handler(context);
  fn[_isUnwrappable] = true;
  return fn;
};
var isUnwrappable = (fn) => typeof fn === "function" && fn[_isUnwrappable] === true;

// src/utils/resolveProp.ts
var resolveProp = async ({ path: [firstProp, ...path], app, context }) => {
  const unwrappedApp = isUnwrappable(app) ? await app(context) : app;
  if (!unwrappedApp)
    throw new (0, _chunk6J4V2ZZ4cjs.PathError)(`Path could not be found in the app.`);
  if (context.type === "request" && isSubject(unwrappedApp))
    throw new (0, _chunk6J4V2ZZ4cjs.PathError)(`Subjects may not be accessed by the client.`);
  const property = firstProp == null ? void 0 : unwrappedApp[firstProp];
  return property ? resolveProp({ path, app: property, context }) : unwrappedApp;
};

// src/utils/toRequest.ts
var parseIncomingMessageUrl = (req) => {
  const protocol = req.socket.encrypted ? "https" : "http";
  const baseUrl = `${protocol}://${req.headers.host}`;
  return req.url ? new URL(req.url, baseUrl) : new URL(baseUrl);
};
var getHttpMessageBody = (incomingMessage) => new Promise((resolve) => {
  const body = [];
  incomingMessage.on("data", (chunk) => body.push(chunk));
  incomingMessage.on("end", () => resolve(new Blob(body)));
});
var toRequest = async (incomingMessage) => new Request(parseIncomingMessageUrl(incomingMessage), {
  method: incomingMessage.method,
  headers: incomingMessage.headers,
  body: await getHttpMessageBody(incomingMessage)
});

// src/utils/isObject.ts
var isObject = (object) => typeof object === "object" && object !== null;

// src/utils/merge.ts
var merge2 = (a, b) => Object.fromEntries(
  [
    ...Object.entries(a),
    ...Object.entries(b).map(
      ([key, value]) => [
        key,
        value && a[key] && isObject(value) && isObject(a[key]) ? merge2(a[key], value) : value
      ]
    )
  ]
);
var merge = ([first, second, ...rest]) => second ? merge([merge2(first, second), ...rest]) : first;

// src/createController.ts
var accessHeaders = {
  "Access-Control-Allow-Methods": "OPTIONS, POST"
};
var getData = async (req) => {
  const arrayBuffer = await req.arrayBuffer();
  const buffer = Buffer.from(arrayBuffer);
  return _msgpackr.unpack.call(void 0, buffer);
};
var encodeResponse = (data, responseInit) => new Response(_msgpackr.pack.call(void 0, data), responseInit);
var handleRequestData = async (app, request, data) => {
  switch (data.type) {
    case "all":
      return Promise.all(data.data.map((d) => handleRequestData(app, request, d)));
    case "allSettled":
      return Promise.allSettled(data.data.map((d) => handleRequestData(app, request, d).catch((e) => {
        throw e instanceof Error ? { message: e.message } : e;
      })));
    case "allSequential":
      return Array.fromAsync(data.data.map((d) => () => handleRequestData(app, request, d)), (fn) => fn());
    case "allSettledSequential":
      return Array.fromAsync(
        data.data.map((d) => () => handleRequestData(app, request, d).then((value) => ({ status: "fulfilled", value })).catch((e) => ({ status: "rejected", reason: e instanceof Error ? { message: e.message } : e }))),
        (fn) => fn()
      );
    case "request":
  }
  const handler = await resolveProp({ app, path: data.path, context: { type: "request", request } });
  if (typeof handler !== "function") {
    throw new (0, _chunk6J4V2ZZ4cjs.PathError)(`Path "${data.path.join(".")}" could not be found in the app.`);
  }
  return handler(...data.args);
};
var reduceResponseInit = (data, responseInit = {}) => {
  if (isResponseInitObject(data)) {
    return respondWith(data.data, { ...responseInit, ...data.responseInit });
  }
  if (data && typeof data === "object" && "value" in data && isResponseInitObject(data.value)) {
    return reduceResponseInit(data.value, responseInit);
  }
  if (Array.isArray(data)) {
    const array = data.map((d) => reduceResponseInit(d, responseInit));
    return respondWith(
      array.map(({ data: data2 }) => data2),
      merge([responseInit, ...array.map(({ responseInit: responseInit2 }) => responseInit2).filter(Boolean)])
    );
  }
  return respondWith(data, responseInit);
};
var handleRequest = async (app, request) => {
  try {
    const data = _chunk6J4V2ZZ4cjs.assertRequestData.call(void 0, await getData(request));
    const res = await handleRequestData(app, request, data);
    const response = reduceResponseInit(res);
    return encodeResponse(response.data, response.responseInit);
  } catch (e) {
    if (e instanceof _chunk6J4V2ZZ4cjs.BodyParsingError) {
      return encodeResponse({ message: e.message }, { status: 400 });
    }
    if (e instanceof _chunk6J4V2ZZ4cjs.PathError) {
      return encodeResponse({ message: e.message }, { status: 404 });
    }
    if (e instanceof Error) {
      return encodeResponse({ message: e.message }, { status: 400 });
    }
    return encodeResponse({ message: "Something went wrong." }, { status: 400 });
  }
};
var isServerResponse = (object) => object instanceof _http.ServerResponse;
var createController = (app) => async (request, arg2) => {
  const serverResponse = isServerResponse(arg2) ? arg2 : void 0;
  const req = request instanceof Request ? request : await toRequest(request);
  if (req.method === "OPTIONS") {
    _optionalChain([serverResponse, 'optionalAccess', _3 => _3.writeHead, 'call', _4 => _4(204, accessHeaders)]);
    _optionalChain([serverResponse, 'optionalAccess', _5 => _5.end, 'call', _6 => _6()]);
    return new Response(void 0, { headers: accessHeaders, status: 204 });
  }
  const res = await handleRequest(app, req);
  if (serverResponse) {
    serverResponse.statusCode = res.status;
    serverResponse.statusMessage = res.statusText;
    res.headers.forEach((value, key) => serverResponse.setHeader(key, value));
    serverResponse.end(Buffer.from(await (await res.blob()).arrayBuffer()));
  }
  return res;
};

// src/createSubscriptionController.ts

var _ws = require('ws');

// src/utils/rawDataToBuffer.ts
var rawDataToBuffer = (data) => data instanceof Buffer ? data : Array.isArray(data) ? Buffer.concat(data) : Buffer.from(data);

// src/createSubscriptionController.ts
var getData2 = (message) => {
  const buffer = rawDataToBuffer(message);
  const data = _msgpackr.unpack.call(void 0, buffer);
  return data;
};
var createSubscriptionController = (app, { subscribeKey = "subscribe" } = {}) => {
  const subjectUnsubscribes = [];
  const unsubscribeAll = () => subjectUnsubscribes.forEach((unsubscribe) => unsubscribe());
  const handleMessage = async (ws, message) => {
    if (typeof message === "string")
      return;
    const { type, auth, path, args } = getData2(message);
    try {
      if (typeof type !== "string") {
        throw new (0, _chunk6J4V2ZZ4cjs.BodyParsingError)("Could not parse body. `type` must be a string.");
      }
      if (auth && typeof auth !== "string") {
        throw new (0, _chunk6J4V2ZZ4cjs.BodyParsingError)("Could not parse body. `auth` must be a string or undefined.");
      }
      if (!Array.isArray(path) || !_chunk6J4V2ZZ4cjs.everyItemIsString.call(void 0, path)) {
        throw new (0, _chunk6J4V2ZZ4cjs.BodyParsingError)("Could not parse body. `path` must be an array of strings.");
      }
      if (!Array.isArray(args)) {
        throw new (0, _chunk6J4V2ZZ4cjs.BodyParsingError)("Could not parse body. Args must be an array.");
      }
      if (type !== "subscribe")
        return;
      if (path.at(-1) !== subscribeKey)
        return;
      const subscribe = await resolveProp({ path, app, context: { type: "message", auth } });
      if (typeof subscribe !== "function")
        return;
      const unsubscribe = args.length ? subscribe(...args)((message2) => {
        ws.send(_msgpackr.pack.call(void 0, {
          type: "event",
          path,
          message: message2
        }));
      }) : subscribe((message2) => {
        ws.send(_msgpackr.pack.call(void 0, {
          type: "event",
          path,
          message: message2
        }));
      });
      subjectUnsubscribes.push(unsubscribe);
    } catch (e) {
      if (e instanceof Error) {
        ws.send(_msgpackr.pack.call(void 0, { type: "error", path, message: { message: e.message, name: e.name } }));
      }
    }
  };
  const connect = (ws) => {
    if ("on" in ws) {
      ws.on("message", (data) => {
        handleMessage(ws, data);
      });
      ws.on("close", unsubscribeAll);
    }
  };
  const createWebSocketServer = (request, socket, head) => {
    const webSocketServer = new (0, _ws.WebSocketServer)({ noServer: true });
    webSocketServer.on("connection", connect);
    webSocketServer.handleUpgrade(request, socket, head, (ws) => {
      webSocketServer.emit("connection", ws, request);
    });
  };
  return {
    createWebSocketServer,
    handleRequest: createController(app),
    unsubscribeAll,
    websocketHandlers: {
      close: unsubscribeAll,
      message: handleMessage,
      open: connect
    }
  };
};

// src/defineApp.ts
var defineApp = (app) => app;







exports.createController = createController; exports.createSubject = createSubject; exports.createSubscriptionController = createSubscriptionController; exports.defineApp = defineApp; exports.respondWith = respondWith; exports.unwrap = unwrap;
